"use strict";
exports.__esModule = true;
var defaults_1 = require("./defaults");
exports.defaultOptions = defaults_1.defaultOptions;
var ProviderInput_1 = require("./ProviderInput");
var ProviderOutput_1 = require("./ProviderOutput");
var store_1 = require("./store");
var lodash_1 = require("lodash");
exports["default"] = (function (options) {
    options = lodash_1.extend({}, defaults_1.defaultOptions, options);
    var store = store_1["default"](options);
    var input = ProviderInput_1["default"](options, store);
    var output = ProviderOutput_1["default"](options, store);
    return {
        store: store,
        input: input,
        output: output
    };
});
