export declare namespace MemoryTree {
    type DataBuffer = Buffer | string | {};
    interface Build {
        (pathname: string, withbuilding?: boolean): Promise<any>;
    }
    interface BuildProvider {
        (options: Options, store: Store): Build;
    }
    interface Store {
        setBuilding: {
            (num: 1 | -1): void;
        };
        isBuilding: {
            (): boolean;
        };
        _set: {
            (path: string, data: DataBuffer): void;
        };
        _get: {
            (path: string): DataBuffer;
        };
        load: {
            (path: string): Promise<DataBuffer>;
        };
    }
    interface Options {
        root: string;
        dest?: string;
        watch: boolean;
        buildFilter?: {
            (pathname: string): boolean;
        };
        buildWatcher?: {
            (pathname: string, eventType: string, build: Build, store: Store): void;
        };
        onSet: {
            (pathname: string, data: DataBuffer, store: Store): Promise<{
                data: DataBuffer;
                outputPath: string;
                originPath: string;
            }>;
        };
        onGet: {
            (pathname: string, data: DataBuffer, store: Store): Promise<DataBuffer>;
        };
        outputFilter?: {
            (pathname: string): boolean;
        };
    }
    interface MemoryTree {
        store: MemoryTree.Store;
        input: MemoryTree.Build;
        output: MemoryTree.Build;
    }
}
